# pict-rs 0.4.7

## Overview

pict-rs 0.4.7 improves error logging for the internal upgrade endpoint introduced in 0.4.6. It also
introduces a new internal endpoint to clean up records for missing files.

### Features

- [Prune Missing Endpoint](#prune-missing-endpoint)


### Changes

- [Improved Upgrade Preparation Logging](#improved-upgrade-preparation-logging)
- [Updated Multipart Library](#updated-multipart-library)


## Upgrade Notes

There's no significant changes from 0.4.5, so upgrading should be as simple as pulling a new version
of pict-rs.


## Descriptions

### Prune Missing Endpoint

In some cases (likely due to a problem with migrating to object storage), there can be records in
pict-rs referencing media that doesn't exist. This case is rare, so this endpoint shouldn't be
useful for too many folks. However, if many files in your pict-rs deployment are missing, this
endpoint can be called to begin removing the invalid records.

The API for this endpoint is described in the
[pict-rs readme](https://git.asonix.dog/asonix/pict-rs/src/branch/v0.4.x/README.md);


### Improved Upgrade Preparation Logging

When generating new details for media fails in the upgrade preparation endpoint, the logged errors
were not especially helpful. This release improves the usefulness of these errors to admins can know
what is actually going wrong.


### Updated Multipart Library

In rare cases, multipart uploads can get stuck. I've updated the actix-form-data library to better
handle edge cases during uploads.
